//+------------------------------------------------------------------+
//|                                            Comment Indicator.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_chart_window
//---- input parameters

//comment variables
extern string Comment1 = "";
extern string Comment2 = "";
extern string Comment3 = "";
extern string Comment4 = "";
extern string Comment5 = "";
extern string     CommentDescription           = "CommentIndictor";
extern bool       DisplayComments            = true;
extern color      CommentsColor              = Black;
extern int        fontsize                   = 14;
extern string     font                       = "Arial"; // "TimesNewRoman"
extern int        CommentSpacing             = 20;

// running clock
int clock = 182;
string objectName = "";

//for previous comments 
string prevComment1 = "";
string prevComment2 = "";
string prevComment3 = "";
string prevComment4 = "";
string prevComment5 = "";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
      objectName = Period()+"M"+Symbol()+CommentDescription;
      return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
// delete comment objects
    DeleteAllObjects();
    Comment("");

    return(0);
  }
//+------------------------------------------------------------------+
//| Delete All Objects                                               |
//+------------------------------------------------------------------+ 
void DeleteAllObjects()
{
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if (StringFind(name,objectName,0)>-1) ObjectDelete(name);
      WindowRedraw();
   }
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//=============== 
 
 if (DisplayComments)
 {
   if(IsTesting()==false)
   {
      Display_Info();
   }
 }

//================== End Start Method
}      

//+------------------------------------------------------------------+
//| expert functions                                                 |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Display Information on the Chart                                 |
//+------------------------------------------------------------------+
void Display_Info()
{
   //draw comment lines
  
   clock++;
   if(clock>194)
   {
      clock=183;
   }  
   int ydistClock = CommentSpacing;
   int ydist1 = ydistClock + CommentSpacing;
   int ydist2 = ydist1 + CommentSpacing;
   int ydist3 = ydist2 + CommentSpacing;
   int ydist4 = ydist3 + CommentSpacing;
   int ydist5 = ydist4 + CommentSpacing;
    if(ObjectFind(objectName+"Clock")==-1)
   {
      ObjectCreate(objectName+"Clock",OBJ_LABEL,0,0,0,0,0,0,0);
      ObjectSetText(objectName+"Clock",CharToStr(clock),14,"Wingdings",CommentsColor);
      ObjectSet(objectName+"Clock",OBJPROP_XDISTANCE,0);
      ObjectSet(objectName+"Clock",OBJPROP_YDISTANCE,ydistClock);
   }
   else
   {
      ObjectDelete(objectName+"Clock");
      ObjectCreate(objectName+"Clock",OBJ_LABEL,0,0,0,0,0,0,0);
      ObjectSetText(objectName+"Clock",CharToStr(clock),14,"Wingdings",CommentsColor);
      ObjectSet(objectName+"Clock",OBJPROP_XDISTANCE,0);
      ObjectSet(objectName+"Clock",OBJPROP_YDISTANCE,ydistClock);
   }
  
   if ((Comment1!="") && (Comment1!= prevComment1))
   {
      if(ObjectFind(objectName+"1")==-1)
      {
         ObjectCreate(objectName+"1",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"1",Comment1,fontsize,font,CommentsColor);
         ObjectSet(objectName+"1",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"1",OBJPROP_YDISTANCE,ydist1);
      }
      else
      {
         ObjectDelete(objectName+"1");
         ObjectCreate(objectName+"1",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"1",Comment1,fontsize,font,CommentsColor);
         ObjectSet(objectName+"1",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"1",OBJPROP_YDISTANCE,ydist1);
      }
      prevComment1 = Comment2;
   } 
   if ((Comment2!="") && (Comment2!= prevComment2))
   {
      if(ObjectFind(objectName+"2")==-1)
      {
         ObjectCreate(objectName+"2",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"2",Comment2,fontsize,font,CommentsColor);
         ObjectSet(objectName+"2",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"2",OBJPROP_YDISTANCE,ydist2);
      }
      else
      {
         ObjectDelete(objectName+"2");
         ObjectCreate(objectName+"2",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"2",Comment2,fontsize,font,CommentsColor);
         ObjectSet(objectName+"2",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"2",OBJPROP_YDISTANCE,ydist2);
      }  
      prevComment2 = Comment2;
   } 
   if ((Comment3!="") && (Comment3!= prevComment3))
   {
      if(ObjectFind(objectName+"3")==-1)
      {
         ObjectCreate(objectName+"3",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"3",Comment3,fontsize,font,CommentsColor);
         ObjectSet(objectName+"3",OBJPROP_XDISTANCE,5);
         ObjectSet(objectName+"3",OBJPROP_YDISTANCE,ydist3);
      }
      else
      {
         ObjectDelete(objectName+"3");
         ObjectCreate(objectName+"3",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"3",Comment3,fontsize,font,CommentsColor);
         ObjectSet(objectName+"3",OBJPROP_XDISTANCE,5);
         ObjectSet(objectName+"3",OBJPROP_YDISTANCE,ydist3);
      }
      prevComment3 = Comment4;
   } 
   if ((Comment4!="") && (Comment4!= prevComment4))
   {
      if(ObjectFind(objectName+"4")==-1)
      {
         ObjectCreate(objectName+"4",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"4",Comment4,fontsize,font,CommentsColor);
         ObjectSet(objectName+"4",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"4",OBJPROP_YDISTANCE,ydist4);
      }
      else
      {
         ObjectDelete(objectName+"4");
         ObjectCreate(objectName+"4",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"4",Comment4,fontsize,font,CommentsColor);
         ObjectSet(objectName+"4",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"4",OBJPROP_YDISTANCE,ydist4);
      }
      prevComment4 = Comment4;
   } 
   if ((Comment5!="") && (Comment4!= prevComment5))
   {
      if(ObjectFind(objectName+"5")==-1)
      {
         ObjectCreate(objectName+"5",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"5",Comment5,fontsize,font,CommentsColor);
         ObjectSet(objectName+"5",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"5",OBJPROP_YDISTANCE,ydist5);  
      }
      else
      {
         ObjectDelete(objectName+"5");
         ObjectCreate(objectName+"5",OBJ_LABEL,0,0,0,0,0,0,0);
         ObjectSetText(objectName+"5",Comment5,fontsize,font,CommentsColor);
         ObjectSet(objectName+"5",OBJPROP_XDISTANCE,0);
         ObjectSet(objectName+"5",OBJPROP_YDISTANCE,ydist5);  
      }   
      prevComment5 = Comment5;
   } 
   return(0);
}

