//+--------------------------------------------------------------------------------------------+
//|   PivotMLevels_v1.0.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_chart_window
#include <stdlib.mqh>
#property indicator_buffers 4
#property indicator_color1 RoyalBlue
#property indicator_color2 RoyalBlue
#property indicator_color3 Crimson
#property indicator_color4 Crimson

int i;
double Range,HiPrice,LoPrice;
double Pivot,R1,R2,S1,S2;

double M4[];
double M3[];
double M2[];
double M1[];

int init()
{
   IndicatorBuffers(4);

   SetIndexStyle(0,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(0,M4);
   
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(1,M3);
   
   SetIndexStyle(2,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(2,M2);
   
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(3,M1);
   
   return(0);
}

int deinit()
{

   ObjectsDeleteAll();
   
   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   
   for (i=Bars-counted_bars;i>=0;i--)
   {
      if (TimeDayOfWeek(Time[i]) != TimeDayOfWeek(Time[i+1]) && TimeDayOfWeek(Time[i]) != 0)
      {
         int shift = iBarShift(NULL,PERIOD_D1,Time[i]) + 1;	// yesterday

         HiPrice = iHigh(NULL,PERIOD_D1,shift);
         LoPrice = iLow(NULL,PERIOD_D1,shift);
         if(TimeDayOfWeek(iTime(NULL,PERIOD_D1,shift))==0/*Sunday*/)
         {//Add friday highs and lows
           HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
           LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_D1,shift+1));
         }

         Range = HiPrice-LoPrice;

         Pivot = (HiPrice+LoPrice+iClose(NULL,PERIOD_D1,shift)) / 3;
         R1 = (2*Pivot) - LoPrice;
         S1 = (2*Pivot) - HiPrice;
         R2 = Pivot + (HiPrice - LoPrice);
         S2 = Pivot - (HiPrice - LoPrice);

         M1[i] = S2 + ((S1-S2)/2);
         M2[i] = S1 + ((Pivot-S1)/2);
         M3[i] = Pivot + ((R1-Pivot)/2);
         M4[i] = R1 + ((R2-R1)/2);
      }
      else
      {
         M1[i] = M1[i+1];
         M2[i] = M2[i+1];
         M3[i] = M3[i+1];
         M4[i] = M4[i+1];
      }
      if (i == 0)
      {DrawPivotExt();}  
   }
   return(0);   
}   
   
void DrawPivotExt()
{
      ObjectDelete("M1");
      ObjectDelete("M1Label");
      ObjectCreate("M1",OBJ_TREND,0,0,0,0,0);
      ObjectSet("M1",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("M1",OBJPROP_PRICE1,M1[i]);
      ObjectSet("M1",OBJPROP_TIME2,Time[i]);
      ObjectSet("M1",OBJPROP_PRICE2,M1[i]);
      ObjectSet("M1",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("M1",OBJPROP_WIDTH,1);
      ObjectSet("M1",OBJPROP_RAY,True);
      ObjectSet("M1",OBJPROP_COLOR,Crimson);
      ObjectCreate("M1Label",OBJ_TEXT,0,Time[i],M1[i],0,0);
      ObjectSetText("M1Label", "                 M1",8,"Arial",Crimson);

      ObjectDelete("M2");
      ObjectDelete("M2Label");
      ObjectCreate("M2",OBJ_TREND,0,0,0,0,0);
      ObjectSet("M2",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("M2",OBJPROP_PRICE1,M2[i]);
      ObjectSet("M2",OBJPROP_TIME2,Time[i]);
      ObjectSet("M2",OBJPROP_PRICE2,M2[i]);
      ObjectSet("M2",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("M2",OBJPROP_WIDTH,1);
      ObjectSet("M2",OBJPROP_RAY,True);
      ObjectSet("M2",OBJPROP_COLOR,Crimson);
      ObjectCreate("M2Label",OBJ_TEXT,0,Time[i],M2[i],0,0);
      ObjectSetText("M2Label", "                 M2",8,"Arial",Crimson);

      ObjectDelete("M3");
      ObjectDelete("M3Label");
      ObjectCreate("M3",OBJ_TREND,0,0,0,0,0);
      ObjectSet("M3",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("M3",OBJPROP_PRICE1,M3[i]);
      ObjectSet("M3",OBJPROP_TIME2,Time[i]);
      ObjectSet("M3",OBJPROP_PRICE2,M3[i]);
      ObjectSet("M3",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("M3",OBJPROP_WIDTH,1);
      ObjectSet("M3",OBJPROP_RAY,True);
      ObjectSet("M3",OBJPROP_COLOR,RoyalBlue);
      ObjectCreate("M3Label",OBJ_TEXT,0,Time[i],M3[i],0,0);
      ObjectSetText("M3Label", "                 M3",8,"Arial",RoyalBlue);

      ObjectDelete("M4");
      ObjectDelete("M4Label");
      ObjectCreate("M4",OBJ_TREND,0,0,0,0,0);
      ObjectSet("M4",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("M4",OBJPROP_PRICE1,M4[i]);
      ObjectSet("M4",OBJPROP_TIME2,Time[i]);
      ObjectSet("M4",OBJPROP_PRICE2,M4[i]);
      ObjectSet("M4",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("M4",OBJPROP_WIDTH,1);
      ObjectSet("M4",OBJPROP_RAY,True);
      ObjectSet("M4",OBJPROP_COLOR,RoyalBlue);
      ObjectCreate("M4Label",OBJ_TEXT,0,Time[i],M4[i],0,0);
      ObjectSetText("M4Label", "                 M4",8,"Arial",RoyalBlue);

}

//+--------------------------------------------------------------------------------------------+