//+--------------------------------------------------------------------------------------------+
//|   PivotPoints_v1.0.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_chart_window
#include <stdlib.mqh>
#property indicator_buffers 7
#property indicator_color1 RoyalBlue
#property indicator_color2 RoyalBlue
#property indicator_color3 RoyalBlue
#property indicator_color4 Green
#property indicator_color5 Crimson
#property indicator_color6 Crimson
#property indicator_color7 Crimson

int i;
double Range,HiPrice,LoPrice;

double R3[];
double R2[];
double R1[];
double Pivot[];
double S1[];
double S2[];
double S3[];

int init()
{
   IndicatorBuffers(7);

   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0,R3);
   
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(1,R2);
   
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(2,R1);
   
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(3,Pivot);
   
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(4,S1);
   
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(5,S2);
   
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(6,S3);
   
   return(0);
}

int deinit()
{

   ObjectsDeleteAll();
   
   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   
   for (i=Bars-counted_bars;i>=0;i--)
   {
//      if (iBarShift(NULL,PERIOD_D1,Time[i]) != iBarShift(NULL,PERIOD_D1,Time[i+1]) && TimeDayOfWeek(Time[i]) != 0)
      if (TimeDayOfWeek(Time[i]) != TimeDayOfWeek(Time[i+1]) && TimeDayOfWeek(Time[i]) != 0)
      {
         int shift = iBarShift(NULL,PERIOD_D1,Time[i]) + 1;	// yesterday

         HiPrice = iHigh(NULL,PERIOD_D1,shift);
         LoPrice = iLow(NULL,PERIOD_D1,shift);
         if(TimeDayOfWeek(iTime(NULL,PERIOD_D1,shift))==0/*Sunday*/)
         {//Add friday highs and lows
           HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
           LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_D1,shift+1));
         }

         Range = HiPrice-LoPrice;

//         Pivot[i] = (HiPrice+LoPrice+iClose(NULL,PERIOD_D1,iBarShift(NULL,PERIOD_D1,Time[i])+1)) / 3;
         Pivot[i] = (HiPrice+LoPrice+iClose(NULL,PERIOD_D1,shift)) / 3;
         R1[i] = (2*Pivot[i]) - LoPrice;
         S1[i] = (2*Pivot[i]) - HiPrice;
         R2[i] = Pivot[i] + (HiPrice - LoPrice);
         S2[i] = Pivot[i] - (HiPrice - LoPrice);
         R3[i] = (2*Pivot[i]) + (HiPrice - (2*LoPrice));
         S3[i] = (2*Pivot[i]) - ((2*HiPrice) - LoPrice); 
      }
      else
      {
         R3[i] = R3[i+1];
         R2[i] = R2[i+1];
         R1[i] = R1[i+1];
         Pivot[i] = Pivot[i+1];
         S1[i] = S1[i+1];
         S2[i] = S2[i+1];
         S3[i] = S3[i+1];
      }
      if (i == 0)
      {DrawPivotExt();}  
   }
   return(0);   
}   
   
void DrawPivotExt()
{
      ObjectDelete("Pivot");
      ObjectDelete("PivotLabel");
      ObjectCreate("Pivot",OBJ_TREND,0,0,0,0,0);
      ObjectSet("Pivot",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("Pivot",OBJPROP_PRICE1,Pivot[i]);
      ObjectSet("Pivot",OBJPROP_TIME2,Time[i]);
      ObjectSet("Pivot",OBJPROP_PRICE2,Pivot[i]);
      ObjectSet("Pivot",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Pivot",OBJPROP_WIDTH,1);
      ObjectSet("Pivot",OBJPROP_RAY,True);
      ObjectSet("Pivot",OBJPROP_COLOR,Green);
      ObjectCreate("PivotLabel",OBJ_TEXT,0,Time[i],Pivot[i],0,0);
      ObjectSetText("PivotLabel", "                 Pivot",8,"Arial",Green);

      ObjectDelete("R1");
      ObjectDelete("R1Label");
      ObjectCreate("R1",OBJ_TREND,0,0,0,0,0);
      ObjectSet("R1",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("R1",OBJPROP_PRICE1,R1[i]);
      ObjectSet("R1",OBJPROP_TIME2,Time[i]);
      ObjectSet("R1",OBJPROP_PRICE2,R1[i]);
      ObjectSet("R1",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("R1",OBJPROP_WIDTH,1);
      ObjectSet("R1",OBJPROP_RAY,True);
      ObjectSet("R1",OBJPROP_COLOR,RoyalBlue);
      ObjectCreate("R1Label",OBJ_TEXT,0,Time[i],R1[i],0,0);
      ObjectSetText("R1Label", "                 R1",8,"Arial",RoyalBlue);

      ObjectDelete("R2");
      ObjectDelete("R2Label");
      ObjectCreate("R2",OBJ_TREND,0,0,0,0,0);
      ObjectSet("R2",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("R2",OBJPROP_PRICE1,R2[i]);
      ObjectSet("R2",OBJPROP_TIME2,Time[i]);
      ObjectSet("R2",OBJPROP_PRICE2,R2[i]);
      ObjectSet("R2",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("R2",OBJPROP_WIDTH,1);
      ObjectSet("R2",OBJPROP_RAY,True);
      ObjectSet("R2",OBJPROP_COLOR,RoyalBlue);
      ObjectCreate("R2Label",OBJ_TEXT,0,Time[i],R2[i],0,0);
      ObjectSetText("R2Label", "                 R2",8,"Arial",RoyalBlue);

      ObjectDelete("R3");
      ObjectDelete("R3Label");
      ObjectCreate("R3",OBJ_TREND,0,0,0,0,0);
      ObjectSet("R3",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("R3",OBJPROP_PRICE1,R3[i]);
      ObjectSet("R3",OBJPROP_TIME2,Time[i]);
      ObjectSet("R3",OBJPROP_PRICE2,R3[i]);
      ObjectSet("R3",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("R3",OBJPROP_WIDTH,1);
      ObjectSet("R3",OBJPROP_RAY,True);
      ObjectSet("R3",OBJPROP_COLOR,RoyalBlue);
      ObjectCreate("R3Label",OBJ_TEXT,0,Time[i],R3[i],0,0);
      ObjectSetText("R3Label", "                 R3",8,"Arial",RoyalBlue);

      ObjectDelete("S1");
      ObjectDelete("S1Label");
      ObjectCreate("S1",OBJ_TREND,0,0,0,0,0);
      ObjectSet("S1",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("S1",OBJPROP_PRICE1,S1[i]);
      ObjectSet("S1",OBJPROP_TIME2,Time[i]);
      ObjectSet("S1",OBJPROP_PRICE2,S1[i]);
      ObjectSet("S1",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("S1",OBJPROP_WIDTH,1);
      ObjectSet("S1",OBJPROP_RAY,True);
      ObjectSet("S1",OBJPROP_COLOR,Crimson);
      ObjectCreate("S1Label",OBJ_TEXT,0,Time[i],S1[i],0,0);
      ObjectSetText("S1Label", "                 S1",8,"Arial",Crimson);

      ObjectDelete("S2");
      ObjectDelete("S2Label");
      ObjectCreate("S2",OBJ_TREND,0,0,0,0,0);
      ObjectSet("S2",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("S2",OBJPROP_PRICE1,S2[i]);
      ObjectSet("S2",OBJPROP_TIME2,Time[i]);
      ObjectSet("S2",OBJPROP_PRICE2,S2[i]);
      ObjectSet("S2",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("S2",OBJPROP_WIDTH,1);
      ObjectSet("S2",OBJPROP_RAY,True);
      ObjectSet("S2",OBJPROP_COLOR,Crimson);
      ObjectCreate("S2Label",OBJ_TEXT,0,Time[i],S2[i],0,0);
      ObjectSetText("S2Label", "                 S2",8,"Arial",Crimson);

      ObjectDelete("S3");
      ObjectDelete("S3Label");
      ObjectCreate("S3",OBJ_TREND,0,0,0,0,0);
      ObjectSet("S3",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("S3",OBJPROP_PRICE1,S3[i]);
      ObjectSet("S3",OBJPROP_TIME2,Time[i]);
      ObjectSet("S3",OBJPROP_PRICE2,S3[i]);
      ObjectSet("S3",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("S3",OBJPROP_WIDTH,1);
      ObjectSet("S3",OBJPROP_RAY,True);
      ObjectSet("S3",OBJPROP_COLOR,Crimson);
      ObjectCreate("S3Label",OBJ_TEXT,0,Time[i],S3[i],0,0);
      ObjectSetText("S3Label", "                 S3",8,"Arial",Crimson);

}

//+--------------------------------------------------------------------------------------------+